diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/mgt-headers.h ns-3.31/src/wifi/model/mgt-headers.h
--- ns-3.30.1/src/wifi/model/mgt-headers.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/mgt-headers.h	2020-06-27 17:38:30.000000000 -0700
@@ -79,27 +79,27 @@
   /**
    * Set the Extended Capabilities.
    *
-   * \param extendedcapabilities the Extended Capabilities
+   * \param extendedCapabilities the Extended Capabilities
    */
-  void SetExtendedCapabilities (ExtendedCapabilities extendedcapabilities);
+  void SetExtendedCapabilities (ExtendedCapabilities extendedCapabilities);
   /**
    * Set the HT capabilities.
    *
-   * \param htcapabilities HT capabilities
+   * \param htCapabilities HT capabilities
    */
-  void SetHtCapabilities (HtCapabilities htcapabilities);
+  void SetHtCapabilities (HtCapabilities htCapabilities);
   /**
    * Set the VHT capabilities.
    *
-   * \param vhtcapabilities VHT capabilities
+   * \param vhtCapabilities VHT capabilities
    */
-  void SetVhtCapabilities (VhtCapabilities vhtcapabilities);
+  void SetVhtCapabilities (VhtCapabilities vhtCapabilities);
   /**
    * Set the HE capabilities.
    *
-   * \param hecapabilities HE capabilities
+   * \param heCapabilities HE capabilities
    */
-  void SetHeCapabilities (HeCapabilities hecapabilities);
+  void SetHeCapabilities (HeCapabilities heCapabilities);
   /**
    * Return the Capability information.
    *
@@ -210,27 +210,27 @@
   /**
    * Set the Extended Capabilities.
    *
-   * \param extendedcapabilities the Extended Capabilities
+   * \param extendedCapabilities the Extended Capabilities
    */
-  void SetExtendedCapabilities (ExtendedCapabilities extendedcapabilities);
+  void SetExtendedCapabilities (ExtendedCapabilities extendedCapabilities);
   /**
    * Set the HT capabilities.
    *
-   * \param htcapabilities HT capabilities
+   * \param htCapabilities HT capabilities
    */
-  void SetHtCapabilities (HtCapabilities htcapabilities);
+  void SetHtCapabilities (HtCapabilities htCapabilities);
   /**
    * Set the VHT capabilities.
    *
-   * \param vhtcapabilities VHT capabilities
+   * \param vhtCapabilities VHT capabilities
    */
-  void SetVhtCapabilities (VhtCapabilities vhtcapabilities);
+  void SetVhtCapabilities (VhtCapabilities vhtCapabilities);
   /**
    * Set the HE capabilities.
    *
-   * \param hecapabilities HE capabilities
+   * \param heCapabilities HE capabilities
    */
-  void SetHeCapabilities (HeCapabilities hecapabilities);
+  void SetHeCapabilities (HeCapabilities heCapabilities);
   /**
    * Return the Capability information.
    *
@@ -382,6 +382,12 @@
    */
   HeOperation GetHeOperation (void) const;
   /**
+   * Return the association ID.
+   *
+   * \return the association ID
+   */
+  uint16_t GetAssociationId (void) const;
+  /**
    * Return the ERP information.
    *
    * \return the ERP information
@@ -402,33 +408,33 @@
   /**
    * Set the extended capabilities.
    *
-   * \param extendedcapabilities the extended capabilities
+   * \param extendedCapabilities the extended capabilities
    */
-  void SetExtendedCapabilities (ExtendedCapabilities extendedcapabilities);
+  void SetExtendedCapabilities (ExtendedCapabilities extendedCapabilities);
   /**
    * Set the VHT operation.
    *
-   * \param vhtoperation VHT operation
+   * \param vhtOperation VHT operation
    */
-  void SetVhtOperation (VhtOperation vhtoperation);
+  void SetVhtOperation (VhtOperation vhtOperation);
   /**
    * Set the VHT capabilities.
    *
-   * \param vhtcapabilities VHT capabilities
+   * \param vhtCapabilities VHT capabilities
    */
-  void SetVhtCapabilities (VhtCapabilities vhtcapabilities);
+  void SetVhtCapabilities (VhtCapabilities vhtCapabilities);
   /**
    * Set the HT capabilities.
    *
-   * \param htcapabilities HT capabilities
+   * \param htCapabilities HT capabilities
    */
-  void SetHtCapabilities (HtCapabilities htcapabilities);
+  void SetHtCapabilities (HtCapabilities htCapabilities);
   /**
    * Set the HT operation.
    *
-   * \param htoperation HT operation
+   * \param htOperation HT operation
    */
-  void SetHtOperation (HtOperation htoperation);
+  void SetHtOperation (HtOperation htOperation);
   /**
    * Set the supported rates.
    *
@@ -462,15 +468,15 @@
   /**
    * Set the HE capabilities.
    *
-   * \param hecapabilities HE capabilities
+   * \param heCapabilities HE capabilities
    */
-  void SetHeCapabilities (HeCapabilities hecapabilities);
+  void SetHeCapabilities (HeCapabilities heCapabilities);
   /**
    * Set the HE operation.
    *
-   * \param heoperation HE operation
+   * \param heOperation HE operation
    */
-  void SetHeOperation (HeOperation heoperation);
+  void SetHeOperation (HeOperation heOperation);
 
   /**
    * Register this type.
@@ -488,7 +494,7 @@
   SupportedRates m_rates; //!< List of supported rates
   CapabilityInformation m_capability; //!< Capability information
   StatusCode m_code; //!< Status code
-  uint16_t m_aid; //!< aid
+  uint16_t m_aid; //!< AID
   ExtendedCapabilities m_extendedCapability; //!< extended capabilities
   HtCapabilities m_htCapability; //!< HT capabilities
   HtOperation m_htOperation; //!< HT operation
@@ -525,27 +531,27 @@
   /**
    * Set the extended capabilities.
    *
-   * \param extendedcapabilities the extended capabilities
+   * \param extendedCapabilities the extended capabilities
    */
-  void SetExtendedCapabilities (ExtendedCapabilities extendedcapabilities);
+  void SetExtendedCapabilities (ExtendedCapabilities extendedCapabilities);
   /**
    * Set the HT capabilities.
    *
-   * \param htcapabilities HT capabilities
+   * \param htCapabilities HT capabilities
    */
-  void SetHtCapabilities (HtCapabilities htcapabilities);
+  void SetHtCapabilities (HtCapabilities htCapabilities);
   /**
    * Set the VHT capabilities.
    *
-   * \param vhtcapabilities VHT capabilities
+   * \param vhtCapabilities VHT capabilities
    */
-  void SetVhtCapabilities (VhtCapabilities vhtcapabilities);
+  void SetVhtCapabilities (VhtCapabilities vhtCapabilities);
   /**
    * Set the HE capabilities.
    *
-   * \param hecapabilities HE capabilities
+   * \param heCapabilities HE capabilities
    */
-  void SetHeCapabilities (HeCapabilities hecapabilities);
+  void SetHeCapabilities (HeCapabilities heCapabilities);
   /**
    * Return the Service Set Identifier (SSID).
    *
@@ -714,45 +720,45 @@
   /**
    * Set the extended capabilities.
    *
-   * \param extendedcapabilities the extended capabilities
+   * \param extendedCapabilities the extended capabilities
    */
-  void SetExtendedCapabilities (ExtendedCapabilities extendedcapabilities);
+  void SetExtendedCapabilities (ExtendedCapabilities extendedCapabilities);
   /**
    * Set the HT capabilities.
    *
-   * \param htcapabilities HT capabilities
+   * \param htCapabilities HT capabilities
    */
-  void SetHtCapabilities (HtCapabilities htcapabilities);
+  void SetHtCapabilities (HtCapabilities htCapabilities);
   /**
    * Set the HT operation.
    *
-   * \param htoperation HT operation
+   * \param htOperation HT operation
    */
-  void SetHtOperation (HtOperation htoperation);
+  void SetHtOperation (HtOperation htOperation);
   /**
    * Set the VHT capabilities.
    *
-   * \param vhtcapabilities VHT capabilities
+   * \param vhtCapabilities VHT capabilities
    */
-  void SetVhtCapabilities (VhtCapabilities vhtcapabilities);
+  void SetVhtCapabilities (VhtCapabilities vhtCapabilities);
   /**
    * Set the VHT operation.
    *
-   * \param vhtoperation VHT operation
+   * \param vhtOperation VHT operation
    */
-  void SetVhtOperation (VhtOperation vhtoperation);
+  void SetVhtOperation (VhtOperation vhtOperation);
   /**
    * Set the HE capabilities.
    *
-   * \param hecapabilities HE capabilities
+   * \param heCapabilities HE capabilities
    */
-  void SetHeCapabilities (HeCapabilities hecapabilities);
+  void SetHeCapabilities (HeCapabilities heCapabilities);
   /**
    * Set the HE operation.
    *
-   * \param heoperation HE operation
+   * \param heOperation HE operation
    */
-  void SetHeOperation (HeOperation heoperation);
+  void SetHeOperation (HeOperation heOperation);
   /**
    * Set the Service Set Identifier (SSID).
    *
@@ -792,9 +798,9 @@
   /**
    * Set the CF parameter set.
    *
-   * \param cfparameterset CF parameter set
+   * \param cfParameterSet CF parameter set
    */
-  void SetCfParameterSet (CfParameterSet cfparameterset);
+  void SetCfParameterSet (CfParameterSet cfParameterSet);
   /**
    * Return the time stamp.
    *
@@ -918,7 +924,7 @@
   };
 
   /**
-   * Block ACK action field values
+   * Block Ack Action field values
    * See 802.11 Table 8-202
    */
   enum BlockAckActionValue
@@ -976,7 +982,7 @@
   /**
    * Category value to string function
    * \param value the category value
-   * \returns the categoty value string
+   * \returns the category value string
    */
   std::string CategoryValueToString (CategoryValue value) const;
   /**
@@ -992,7 +998,7 @@
 
 /**
  * \ingroup wifi
- * Implement the header for management frames of type add block ack request.
+ * Implement the header for management frames of type Add Block Ack request.
  */
 class MgtAddBaRequestHeader : public Header
 {
@@ -1011,11 +1017,11 @@
   uint32_t Deserialize (Buffer::Iterator start);
 
   /**
-   * Enable delayed Block ACK.
+   * Enable delayed BlockAck.
    */
   void SetDelayedBlockAck ();
   /**
-   * Enable immediate Block ACK
+   * Enable immediate BlockAck
    */
   void SetImmediateBlockAck ();
   /**
@@ -1062,9 +1068,9 @@
    */
   uint8_t GetTid (void) const;
   /**
-   * Return whether the Block ACK policy is immediate Block ACK.
+   * Return whether the Block Ack policy is immediate Block Ack.
    *
-   * \return true if immediate Block ACK is being used, false otherwise
+   * \return true if immediate Block Ack is being used, false otherwise
    */
   bool IsImmediateBlockAck (void) const;
   /**
@@ -1108,13 +1114,13 @@
   /**
    * Set sequence control with the given raw value.
    *
-   * \param seqControl
+   * \param seqControl the raw sequence control
    */
   void SetStartingSequenceControl (uint16_t seqControl);
 
   uint8_t m_dialogToken;   //!< Not used for now
   uint8_t m_amsduSupport;  //!< Flag if A-MSDU is supported
-  uint8_t m_policy;        //!< Block ACK policy
+  uint8_t m_policy;        //!< Block Ack policy
   uint8_t m_tid;           //!< Traffic ID
   uint16_t m_bufferSize;   //!< Buffer size
   uint16_t m_timeoutValue; //!< Timeout
@@ -1124,7 +1130,7 @@
 
 /**
  * \ingroup wifi
- * Implement the header for management frames of type add block ack response.
+ * Implement the header for management frames of type Add Block Ack response.
  */
 class MgtAddBaResponseHeader : public Header
 {
@@ -1143,11 +1149,11 @@
   uint32_t Deserialize (Buffer::Iterator start);
 
   /**
-   * Enable delayed Block ACK.
+   * Enable delayed BlockAck.
    */
   void SetDelayedBlockAck ();
   /**
-   * Enable immediate Block ACK
+   * Enable immediate BlockAck.
    */
   void SetImmediateBlockAck ();
   /**
@@ -1194,9 +1200,9 @@
    */
   uint8_t GetTid (void) const;
   /**
-   * Return whether the Block ACK policy is immediate Block ACK.
+   * Return whether the Block Ack policy is immediate Block Ack.
    *
-   * \return true if immediate Block ACK is being used, false otherwise
+   * \return true if immediate Block Ack is being used, false otherwise
    */
   bool IsImmediateBlockAck (void) const;
   /**
@@ -1245,7 +1251,7 @@
 
 /**
  * \ingroup wifi
- * Implement the header for management frames of type del block ack.
+ * Implement the header for management frames of type Delete Block Ack.
  */
 class MgtDelBaHeader : public Header
 {
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/minstrel-ht-wifi-manager.cc ns-3.31/src/wifi/model/minstrel-ht-wifi-manager.cc
--- ns-3.30.1/src/wifi/model/minstrel-ht-wifi-manager.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/minstrel-ht-wifi-manager.cc	2020-06-27 17:38:30.000000000 -0700
@@ -100,7 +100,7 @@
                    MakeUintegerAccessor (&MinstrelHtWifiManager::m_nSampleCol),
                    MakeUintegerChecker <uint8_t> ())
     .AddAttribute ("PacketLength",
-                   "The packet length used for calculating mode TxTime",
+                   "The packet length used for calculating mode TxTime (bytes)",
                    UintegerValue (1200),
                    MakeUintegerAccessor (&MinstrelHtWifiManager::m_frameLength),
                    MakeUintegerChecker <uint32_t> ())
@@ -161,7 +161,7 @@
 MinstrelHtWifiManager::SetupPhy (const Ptr<WifiPhy> phy)
 {
   NS_LOG_FUNCTION (this << phy);
-  // Setup phy for legacy manager.
+  // Setup PHY for legacy manager.
   m_legacyManager->SetupPhy (phy);
   WifiRemoteStationManager::SetupPhy (phy);
 }
@@ -188,8 +188,8 @@
    * Then, after all initializations are finished, we check actual support for each receiving station.
    */
 
-  // Check if the device supports HT or VHT
-  if (GetHtSupported () || GetVhtSupported ())
+  // Check if the device supports HT
+  if (GetHtSupported ())
     {
       m_numGroups = MAX_SUPPORTED_STREAMS * MAX_HT_STREAM_GROUPS;
       m_numRates = MAX_HT_GROUP_RATES;
@@ -207,7 +207,7 @@
        *  - A global continuous index, which identifies all rates within all groups, in [0, m_numGroups * m_numRates]
        *  - A groupId, which indexes a group in the array, in [0, m_numGroups]
        *  - A rateId, which identifies a rate within a group, in [0, m_numRates]
-       *  - A deviceIndex, which indexes a MCS in the phy MCS array.
+       *  - A deviceIndex, which indexes a MCS in the PHY MCS array.
        *  - A mcsIndex, which indexes a MCS in the wifi-remote-station-manager supported MCSs array.
        */
       NS_LOG_DEBUG ("Initialize MCS Groups:");
@@ -235,7 +235,7 @@
                     {
                       m_minstrelGroups[groupId].isSupported = true;
 
-                      // Calculate tx time for all rates of the group
+                      // Calculate TX time for all rates of the group
                       WifiModeList htMcsList = GetHtDeviceMcsList ();
                       for (uint8_t i = 0; i < MAX_HT_GROUP_RATES; i++)
                         {
@@ -274,7 +274,7 @@
                         {
                           m_minstrelGroups[groupId].isSupported = true;
 
-                          // Calculate tx time for all rates of the group
+                          // Calculate TX time for all rates of the group
                           WifiModeList vhtMcsList = GetVhtDeviceMcsList ();
                           for (uint8_t i = 0; i < MAX_VHT_GROUP_RATES; i++)
                             {
@@ -319,7 +319,8 @@
   txvector.SetStbc (0);
   txvector.SetMode (mode);
   txvector.SetPreambleType (WIFI_PREAMBLE_HT_MF);
-  return phy->CalculateTxDuration (m_frameLength, txvector, phy->GetFrequency (), mpduType, 0);
+  return WifiPhy::CalculatePhyPreambleAndHeaderDuration (txvector)
+         + WifiPhy::GetPayloadDuration (m_frameLength, txvector, phy->GetFrequency (), mpduType);
 }
 
 Time
@@ -390,7 +391,7 @@
   station->m_ampduPacketCount = 0;
 
   // If the device supports HT
-  if (GetHtSupported () || GetVhtSupported ())
+  if (GetHtSupported ())
     {
       /**
        * Assume the station is HT.
@@ -422,9 +423,9 @@
        *  the station will not support HT either.
        *  We save from using another check and variable.
        */
-      if (!GetHtSupported (station) && !GetVhtSupported (station))
+      if (!GetHtSupported (station))
         {
-          NS_LOG_INFO ("Non-HT station " << station);
+          NS_LOG_INFO ("non-HT station " << station);
           station->m_isHt = false;
           // We will use non-HT minstrel for this station. Initialize the manager.
           m_legacyManager->SetAttribute ("UpdateStatistics", TimeValue (m_updateStats));
@@ -444,9 +445,6 @@
           station->m_sampleTable = SampleRate (m_numRates, std::vector<uint8_t> (m_nSampleCol));
           InitSampleTable (station);
           RateInit (station);
-          std::ostringstream tmp;
-          tmp << "minstrel-ht-stats-" << station->m_state->m_address << ".txt";
-          station->m_statsFile.open (tmp.str ().c_str (), std::ios::out);
           station->m_initialized = true;
         }
     }
@@ -456,14 +454,14 @@
 MinstrelHtWifiManager::DoReportRxOk (WifiRemoteStation *st, double rxSnr, WifiMode txMode)
 {
   NS_LOG_FUNCTION (this << st);
-  NS_LOG_DEBUG ("DoReportRxOk m_txrate=" << ((MinstrelHtWifiRemoteStation *)st)->m_txrate);
+  NS_LOG_DEBUG ("DoReportRxOk m_txrate=" << static_cast<MinstrelHtWifiRemoteStation*> (st)->m_txrate);
 }
 
 void
 MinstrelHtWifiManager::DoReportRtsFailed (WifiRemoteStation *st)
 {
   NS_LOG_FUNCTION (this << st);
-  MinstrelHtWifiRemoteStation *station = (MinstrelHtWifiRemoteStation *)st;
+  MinstrelHtWifiRemoteStation *station = static_cast<MinstrelHtWifiRemoteStation*> (st);
   CheckInit (station);
   if (!station->m_initialized)
     {
@@ -483,7 +481,7 @@
 MinstrelHtWifiManager::DoReportFinalRtsFailed (WifiRemoteStation *st)
 {
   NS_LOG_FUNCTION (this << st);
-  MinstrelHtWifiRemoteStation *station = (MinstrelHtWifiRemoteStation *)st;
+  MinstrelHtWifiRemoteStation *station = static_cast<MinstrelHtWifiRemoteStation*> (st);
   NS_LOG_DEBUG ("Final RTS failed");
   CheckInit (station);
   if (!station->m_initialized)
@@ -497,7 +495,7 @@
 MinstrelHtWifiManager::DoReportDataFailed (WifiRemoteStation *st)
 {
   NS_LOG_FUNCTION (this << st);
-  MinstrelHtWifiRemoteStation *station = (MinstrelHtWifiRemoteStation *)st;
+  MinstrelHtWifiRemoteStation *station = static_cast<MinstrelHtWifiRemoteStation*> (st);
 
   CheckInit (station);
   if (!station->m_initialized)
@@ -521,10 +519,11 @@
 }
 
 void
-MinstrelHtWifiManager::DoReportDataOk (WifiRemoteStation *st, double ackSnr, WifiMode ackMode, double dataSnr)
+MinstrelHtWifiManager::DoReportDataOk (WifiRemoteStation *st, double ackSnr, WifiMode ackMode,
+                                       double dataSnr, uint16_t dataChannelWidth, uint8_t dataNss)
 {
-  NS_LOG_FUNCTION (this << st << ackSnr << ackMode << dataSnr);
-  MinstrelHtWifiRemoteStation *station = (MinstrelHtWifiRemoteStation *) st;
+  NS_LOG_FUNCTION (this << st << ackSnr << ackMode << dataSnr << dataChannelWidth << +dataNss);
+  MinstrelHtWifiRemoteStation *station = static_cast<MinstrelHtWifiRemoteStation*> (st);
 
   CheckInit (station);
   if (!station->m_initialized)
@@ -584,7 +583,7 @@
 MinstrelHtWifiManager::DoReportFinalDataFailed (WifiRemoteStation *st)
 {
   NS_LOG_FUNCTION (this << st);
-  MinstrelHtWifiRemoteStation *station = (MinstrelHtWifiRemoteStation *) st;
+  MinstrelHtWifiRemoteStation *station = static_cast<MinstrelHtWifiRemoteStation*> (st);
 
   CheckInit (station);
   if (!station->m_initialized)
@@ -628,10 +627,11 @@
 }
 
 void
-MinstrelHtWifiManager::DoReportAmpduTxStatus (WifiRemoteStation *st, uint8_t nSuccessfulMpdus, uint8_t nFailedMpdus, double rxSnr, double dataSnr)
+MinstrelHtWifiManager::DoReportAmpduTxStatus (WifiRemoteStation *st, uint8_t nSuccessfulMpdus, uint8_t nFailedMpdus,
+                                              double rxSnr, double dataSnr, uint16_t dataChannelWidth, uint8_t dataNss)
 {
-  NS_LOG_FUNCTION (this << st << +nSuccessfulMpdus << +nFailedMpdus << rxSnr << dataSnr);
-  MinstrelHtWifiRemoteStation *station = (MinstrelHtWifiRemoteStation *) st;
+  NS_LOG_FUNCTION (this << st << +nSuccessfulMpdus << +nFailedMpdus << rxSnr << dataSnr << dataChannelWidth << +dataNss);
+  MinstrelHtWifiRemoteStation *station = static_cast<MinstrelHtWifiRemoteStation*> (st);
 
   CheckInit (station);
   if (!station->m_initialized)
@@ -641,8 +641,8 @@
 
   NS_ASSERT_MSG (station->m_isHt, "A-MPDU Tx Status called but no HT or VHT supported.");
 
-  NS_LOG_DEBUG ("DoReportAmpduTxStatus. TxRate=" << station->m_txrate << " SuccMpdus= " <<
-                +nSuccessfulMpdus << " FailedMpdus= " << +nFailedMpdus);
+  NS_LOG_DEBUG ("DoReportAmpduTxStatus. TxRate=" << station->m_txrate << " SuccMpdus=" <<
+                +nSuccessfulMpdus << " FailedMpdus=" << +nFailedMpdus);
 
   station->m_ampduPacketCount++;
   station->m_ampduLen += nSuccessfulMpdus + nFailedMpdus;
@@ -700,7 +700,7 @@
    *  3  |  Best probability       | Best probability
    *
    * Note: For clarity, multiple blocks of if's and else's are used
-   * Following implementation in Linux, in MinstrelHT Lowest baserate is not used.
+   * Following implementation in Linux, in MinstrelHT lowest base rate is not used.
    * Explanation can be found here: http://marc.info/?l=linux-wireless&m=144602778611966&w=2
    */
 
@@ -712,7 +712,7 @@
   station->m_longRetry++;
 
   /**
-   * Get the ids for all rates.
+   * Get the IDs for all rates.
    */
   uint8_t maxTpRateId = GetRateId (station->m_maxTpRate);
   uint8_t maxTpGroupId = GetGroupId (station->m_maxTpRate);
@@ -815,7 +815,7 @@
 MinstrelHtWifiManager::DoGetDataTxVector (WifiRemoteStation *st)
 {
   NS_LOG_FUNCTION (this << st);
-  MinstrelHtWifiRemoteStation *station = (MinstrelHtWifiRemoteStation *) st;
+  MinstrelHtWifiRemoteStation *station = static_cast<MinstrelHtWifiRemoteStation*> (st);
 
   if (!station->m_initialized)
     {
@@ -868,7 +868,7 @@
 MinstrelHtWifiManager::DoGetRtsTxVector (WifiRemoteStation *st)
 {
   NS_LOG_FUNCTION (this << st);
-  MinstrelHtWifiRemoteStation *station = (MinstrelHtWifiRemoteStation *) st;
+  MinstrelHtWifiRemoteStation *station = static_cast<MinstrelHtWifiRemoteStation*> (st);
 
   if (!station->m_initialized)
     {
@@ -945,7 +945,7 @@
 {
   NS_LOG_FUNCTION (this << st << packet << normally);
 
-  MinstrelHtWifiRemoteStation *station = (MinstrelHtWifiRemoteStation *)st;
+  MinstrelHtWifiRemoteStation *station = static_cast<MinstrelHtWifiRemoteStation*> (st);
 
   CheckInit (station);
   if (!station->m_initialized)
@@ -999,12 +999,6 @@
     }
 }
 
-bool
-MinstrelHtWifiManager::IsLowLatency (void) const
-{
-  return true;
-}
-
 uint16_t
 MinstrelHtWifiManager::GetNextSample (MinstrelHtWifiRemoteStation *station)
 {
@@ -1276,7 +1270,7 @@
 {
   /**
   * Calculating throughput.
-  * Do not account throughput if success prob is below 10%
+  * Do not account throughput if probability of success is below 10%
   * (as done in minstrel_ht linux implementation).
   */
   if (ewmaProb < 10)
@@ -1439,7 +1433,7 @@
           station->m_groupsTable[groupId].m_supported = false;
           if (!(!GetVhtSupported (station) && m_minstrelGroups[groupId].isVht)                    ///Is VHT supported by the receiver?
               && (m_minstrelGroups[groupId].isVht || !GetVhtSupported (station) || !m_useVhtOnly) ///If it is an HT MCS, check if VHT only is disabled
-              && !(!GetShortGuardIntervalSupported (station) && m_minstrelGroups[groupId].sgi)             ///Is SGI supported by the receiver?
+              && !(!GetShortGuardIntervalSupported (station) && m_minstrelGroups[groupId].sgi)    ///Is SGI supported by the receiver?
               && (GetChannelWidth (station) >= m_minstrelGroups[groupId].chWidth)                 ///Is channel width supported by the receiver?
               && (GetNumberOfSupportedStreams (station) >= m_minstrelGroups[groupId].streams))    ///Are streams supported by the receiver?
             {
@@ -1611,6 +1605,13 @@
 void
 MinstrelHtWifiManager::PrintTable (MinstrelHtWifiRemoteStation *station)
 {
+  if (!station->m_statsFile.is_open ())
+    {
+      std::ostringstream tmp;
+      tmp << "minstrel-ht-stats-" << station->m_state->m_address << ".txt";
+      station->m_statsFile.open (tmp.str ().c_str (), std::ios::out);
+    }
+
   station->m_statsFile << "               best   ____________rate__________    ________statistics________    ________last_______    ______sum-of________\n" <<
     " mode guard #  rate  [name   idx airtime  max_tp]  [avg(tp) avg(prob) sd(prob)]  [prob.|retry|suc|att]  [#success | #attempts]\n";
   for (uint8_t i = 0; i < m_numGroups; i++)
